package org.apache.geronimo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.util.Random;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class for Servlet: AsyncServlet
 * 
 * @web.servlet name="AsyncServlet" display-name="AsyncServlet"
 * 
 * @web.servlet-mapping url-pattern="/async"
 * 
 */
public class BlockingServlet extends HttpServlet {
	static final long serialVersionUID = 1L;

	private String remoteUrl;

	public void init() throws ServletException {
		getServletContext().log("getinit init");
		// Get the value of an initialization parameter
		remoteUrl = getServletConfig().getInitParameter("remoteUrl");
	}

	/**
	 * Process the given Comet event.
	 * 
	 * @param event
	 *            The Comet event that will be processed
	 * @throws IOException
	 * @throws ServletException
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {

		System.out.println("");
		System.out.println("Inside BlockingServlet.doGet()");

		String sessionId = request.getSession(true).getId();

		if (request.getParameter("remoteUrl") != null) {
			remoteUrl = request.getParameter("remoteUrl");
		}

		String remoteUri = request.getParameter("remoteUri");
		if (remoteUri == null) {
			remoteUri = "/remoteApp/page";
		}		

		Integer[] params = generateRandomParams();
		System.out.println("sessionId:" + sessionId + "; delay:" + params[0]
				+ "; code:" + params[1]);

		String url_string = remoteUrl + remoteUri + "?sessionId=" + sessionId + "&delay=" + params[0] + "&code=" + params[1];		
		URL url_connect = new URL(url_string);
		
		try {
			BufferedReader input = new BufferedReader(new InputStreamReader(url_connect.openStream()));
			String line = "";						
			response.setContentType("text/html");
			PrintWriter out = response.getWriter();			
			while ((line = input.readLine()) != null) {				
				out.println(line);
			}
			out.flush();
			out.close();
			input.close();
		}
		catch(IOException ex) {
			response.sendError(params[1].intValue());			
		}
		

		System.out.println("doGet processed");
	}

	protected Integer[] generateRandomParams() {
		Integer[] params = new Integer[2];
		final int[] codes = new int[] { 200, 302, 403, 404, 500 };

		Random generator = new Random();

		// generate a random delay between 10ms and 250 ms
		int delay = generator.nextInt(2000) + 10;
		params[0] = new Integer(delay);

		// generate randomly one of http status codes.
		int index = generator.nextInt(codes.length);
		params[1] = new Integer(codes[index]);

		return params;
	}

}